Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -6263,218 +6262,193 @@
     ions_mol(7) = ions(7) / ( water_total * 18.01528E-3_wp )   ! Cl-
 
-!--    ***
-!-- At this point we may need to introduce a method for prescribing H+ when
-!-- there is no 'real' value for H+..i.e. in the sulphate poor domain
-!-- This will give a value for solve quadratic proposed by Zaveri et al. 2005
+!-- ***
+!-- At this point we may need to introduce a method for prescribing H+ when there is no 'real' value
+!-- for H+..i.e. in the sulphate poor domain. This will give a value for solve quadratic proposed by
+!-- Zaveri et al. 2005
 !
 !-- 2) - WATER CALCULATION
 !
-!-- a) The water content is calculated using the ZSR rule with solute 
-!-- concentrations calculated using 1a above. Whilst the usual approximation of
-!-- ZSR relies on binary data consisting of 5th or higher order polynomials, in
-!-- this code 4 different RH regimes are used, each housing cubic equations for 
-!-- the water associated with each solute listed above. Binary water contents 
-!-- for inorganic components were calculated using AIM online (Clegg et al 
-!-- 1998). The water associated with the organic compound is calculated assuming
-!-- ideality and that aw = RH.
-!
-!-- b) Molality of each inorganic ion and organic solute (initial input) is
-!-- calculated for use in vapour pressure calculation. 
+!-- a) The water content is calculated using the ZSR rule with solute concentrations calculated
+!-- using 1a above. Whilst the usual approximation of ZSR relies on binary data consisting of 5th or
+!-- higher order polynomials, in this code 4 different RH regimes are used, each housing cubic
+!-- equations for the water associated with each solute listed above. Binary water contents for
+!-- inorganic components were calculated using AIM online (Clegg et al 1998). The water associated
+!-- with the organic compound is calculated assuming ideality and that aw = RH.
+!
+!-- b) Molality of each inorganic ion and organic solute (initial input) is calculated for use in
+!-- vapour pressure calculation.
 !
 !-- 3) - BISULPHATE ION DISSOCIATION CALCULATION
 !
-!-- The dissociation of the bisulphate ion is calculated explicitly. A solution
-!-- to the equilibrium equation between the bisulphate ion, hydrogen ion and 
-!-- sulphate ion is found using tabulated equilibrium constants (referenced). It
-!-- is necessary to calculate the activity coefficients of HHSO4 and H2SO4 in a
-!-- non-iterative manner. These are calculated using the same format as 
-!-- described in 4) below, where both activity coefficients were fit to the 
-!-- output from ADDEM (Topping et al 2005a,b) covering an extensive composition
-!-- space, providing the activity coefficients and bisulphate ion dissociation 
-!-- as a function of equivalent mole fractions and relative humidity.
-!
-!-- NOTE: the flags "binary_case" and "full_complexity" are not used in this 
-!-- prototype. They are used for simplification of the fit expressions when 
-!-- using limited composition regions. This section of code calculates the 
-!-- bisulphate ion concentration
+!-- The dissociation of the bisulphate ion is calculated explicitly. A solution to the equilibrium
+!-- equation between the bisulphate ion, hydrogen ion and sulphate ion is found using tabulated
+!-- equilibrium constants (referenced). It is necessary to calculate the activity coefficients of
+!-- HHSO4 and H2SO4 in a non-iterative manner. These are calculated using the same format as
+!-- described in 4) below, where both activity coefficients were fit to the output from ADDEM
+!-- (Topping et al 2005a,b) covering an extensive composition space, providing the activity
+!-- coefficients and bisulphate ion dissociation as a function of equivalent mole fractions and
+!-- relative humidity.
+!
+!-- NOTE: the flags "binary_case" and "full_complexity" are not used in this prototype. They are
+!-- used for simplification of the fit expressions when using limited composition regions. This
+!-- section of code calculates the bisulphate ion concentration.
 !
     IF ( ions(1) > 0.0_wp .AND. ions(4) > 0.0_wp ) THEN
-!       
+!
 !--    HHSO4:
        binary_case = 1
-       IF ( RH > 0.1_wp  .AND.  RH < 0.9_wp )  THEN
-          binary_hhso4 = - 4.9521_wp * ( RH**3 ) + 9.2881_wp * ( RH**2 ) -     &
-                           10.777_wp * RH + 6.0534_wp
-       ELSEIF ( RH >= 0.9_wp  .AND.  RH < 0.955_wp )  THEN
-          binary_hhso4 = - 6.3777_wp * RH + 5.962_wp
-       ELSEIF ( RH >= 0.955_wp  .AND.  RH < 0.99_wp )  THEN
-          binary_hhso4 = 2367.2_wp * ( RH**3 ) - 6849.7_wp * ( RH**2 ) +       &
-                         6600.9_wp * RH - 2118.7_wp    
-       ELSEIF ( RH >= 0.99_wp  .AND.  RH < 0.9999_wp )  THEN
-          binary_hhso4 = 3E-7_wp * ( RH**5 ) - 2E-5_wp * ( RH**4 ) +           &
-                         0.0004_wp * ( RH**3 ) - 0.0035_wp * ( RH**2 ) +       &
-                         0.0123_wp * RH - 0.3025_wp
-       ENDIF
-       
+       IF ( rh > 0.1_wp  .AND.  rh < 0.9_wp )  THEN
+          binary_hhso4 = -4.9521_wp * rh**3 + 9.2881_wp * rh**2 - 10.777_wp * rh + 6.0534_wp
+       ELSEIF ( rh >= 0.9_wp  .AND.  rh < 0.955_wp )  THEN
+          binary_hhso4 = -6.3777_wp * rh + 5.962_wp
+       ELSEIF ( rh >= 0.955_wp  .AND.  rh < 0.99_wp )  THEN
+          binary_hhso4 = 2367.2_wp * rh**3 - 6849.7_wp * rh**2 + 6600.9_wp * rh - 2118.7_wp
+       ELSEIF ( rh >= 0.99_wp  .AND.  rh < 0.9999_wp )  THEN
+          binary_hhso4 = 3E-7_wp * rh**5 - 2E-5_wp * rh**4 + 0.0004_wp * rh**3 - 0.0035_wp * rh**2 &
+                         + 0.0123_wp * rh - 0.3025_wp
+       ENDIF
+
        IF ( nitric_acid > 0.0_wp )  THEN
-          HNO3_hhso4 = - 4.2204_wp * ( RH**4 ) + 12.193_wp * ( RH**3 ) -       &
-                         12.481_wp * ( RH**2 ) + 6.459_wp * RH - 1.9004_wp
-       ENDIF
-       
+          hno3_hhso4 = -4.2204_wp * rh**4 + 12.193_wp * rh**3 - 12.481_wp * rh**2 + 6.459_wp * rh  &
+                       - 1.9004_wp
+       ENDIF
+
        IF ( hydrochloric_acid > 0.0_wp )  THEN
-          HCL_hhso4 = - 54.845_wp * ( RH**7 ) + 209.54_wp * ( RH**6 ) -        &
-                        336.59_wp * ( RH**5 ) + 294.21_wp * ( RH**4 ) -        &
-                        150.07_wp * ( RH**3 ) + 43.767_wp * ( RH**2 ) -        &
-                        6.5495_wp * RH + 0.60048_wp
-       ENDIF
-       
+          hcl_hhso4 = -54.845_wp * rh**7 + 209.54_wp * rh**6 - 336.59_wp * rh**5 + 294.21_wp *     &
+                      rh**4 - 150.07_wp * rh**3 + 43.767_wp * rh**2 - 6.5495_wp * rh + 0.60048_wp
+       ENDIF
+
        IF ( ammonium_sulphate > 0.0_wp )  THEN
-          NH42SO4_hhso4 = 16.768_wp * ( RH**3 ) - 28.75_wp * ( RH**2 ) +       &
-                          20.011_wp * RH - 8.3206_wp
-       ENDIF
-       
+          nh42so4_hhso4 = 16.768_wp * rh**3 - 28.75_wp * rh**2 + 20.011_wp * rh - 8.3206_wp
+       ENDIF
+
        IF ( ammonium_nitrate > 0.0_wp )  THEN
-          NH4NO3_hhso4 = - 17.184_wp * ( RH**4 ) + 56.834_wp * ( RH**3 ) -     &
-                           65.765_wp * ( RH**2 ) + 35.321_wp * RH - 9.252_wp
-       ENDIF
-       
+          nh4no3_hhso4 = -17.184_wp * rh**4 + 56.834_wp * rh**3 - 65.765_wp * rh**2 +              &
+                         35.321_wp * rh - 9.252_wp
+       ENDIF
+
        IF (ammonium_chloride > 0.0_wp )  THEN
-          IF ( RH < 0.2_wp .AND. RH >= 0.1_wp )  THEN
-             NH4Cl_hhso4 = 3.2809_wp * RH - 2.0637_wp
-          ELSEIF ( RH >= 0.2_wp .AND. RH < 0.99_wp )  THEN
-             NH4Cl_hhso4 = - 1.2981_wp * ( RH**3 ) + 4.7461_wp * ( RH**2 ) -   &
-                             2.3269_wp * RH - 1.1259_wp
+          IF ( rh < 0.2_wp .AND. rh >= 0.1_wp )  THEN
+             nh4cl_hhso4 = 3.2809_wp * rh - 2.0637_wp
+          ELSEIF ( rh >= 0.2_wp .AND. rh < 0.99_wp )  THEN
+             nh4cl_hhso4 = -1.2981_wp * rh**3 + 4.7461_wp * rh**2 - 2.3269_wp * rh - 1.1259_wp
           ENDIF
        ENDIF
-       
+
        IF ( sodium_sulphate > 0.0_wp )  THEN
-          Na2SO4_hhso4 = 118.87_wp * ( RH**6 ) - 358.63_wp * ( RH**5 ) +       &
-                         435.85_wp * ( RH**4 ) - 272.88_wp * ( RH**3 ) +       &
-                         94.411_wp * ( RH**2 ) - 18.21_wp * RH + 0.45935_wp
-       ENDIF
-       
+          na2so4_hhso4 = 118.87_wp * rh**6 - 358.63_wp * rh**5 + 435.85_wp * rh**4 - 272.88_wp *   &
+                         rh**3 + 94.411_wp * rh**2 - 18.21_wp * rh + 0.45935_wp
+       ENDIF
+
        IF ( sodium_nitrate > 0.0_wp )  THEN
-          IF ( RH < 0.2_wp  .AND.  RH >= 0.1_wp )  THEN
-             NaNO3_hhso4 = 4.8456_wp * RH - 2.5773_wp    
-          ELSEIF ( RH >= 0.2_wp  .AND.  RH < 0.99_wp )  THEN
-             NaNO3_hhso4 = 0.5964_wp * ( RH**3 ) - 0.38967_wp * ( RH**2 ) +    &
-                           1.7918_wp * RH - 1.9691_wp 
+          IF ( rh < 0.2_wp  .AND.  rh >= 0.1_wp )  THEN
+             nano3_hhso4 = 4.8456_wp * rh - 2.5773_wp
+          ELSEIF ( rh >= 0.2_wp  .AND.  rh < 0.99_wp )  THEN
+             nano3_hhso4 = 0.5964_wp * rh**3 - 0.38967_wp * rh**2 + 1.7918_wp * rh - 1.9691_wp
           ENDIF
        ENDIF
-       
+
        IF ( sodium_chloride > 0.0_wp )  THEN
-          IF ( RH < 0.2_wp )  THEN
-             NaCl_hhso4 = 0.51995_wp * RH - 1.3981_wp
-          ELSEIF ( RH >= 0.2_wp  .AND.  RH < 0.99_wp )  THEN
-             NaCl_hhso4 = 1.6539_wp * RH - 1.6101_wp
+          IF ( rh < 0.2_wp )  THEN
+             nacl_hhso4 = 0.51995_wp * rh - 1.3981_wp
+          ELSEIF ( rh >= 0.2_wp  .AND.  rh < 0.99_wp )  THEN
+             nacl_hhso4 = 1.6539_wp * rh - 1.6101_wp
           ENDIF
        ENDIF
-       
-       Ln_hhso4_act = binary_hhso4 +                                           &
-                      nitric_acid_eq_frac       * HNO3_hhso4 +                 &
-                      hydrochloric_acid_eq_frac * HCL_hhso4 +                  &
-                      ammonium_sulphate_eq_frac * NH42SO4_hhso4 +              &
-                      ammonium_nitrate_eq_frac  * NH4NO3_hhso4 +               &
-                      ammonium_chloride_eq_frac * NH4Cl_hhso4 +                &
-                      sodium_sulphate_eq_frac   * Na2SO4_hhso4 +               &
-                      sodium_nitrate_eq_frac    * NaNO3_hhso4 +                &
-                      sodium_chloride_eq_frac   * NaCl_hhso4
-       gamma_hhso4 = EXP( Ln_hhso4_act )   ! molal activity coefficient of HHSO4
+
+       ln_hhso4_act = binary_hhso4 + nitric_acid_eq_frac * hno3_hhso4 +                            &
+                      hydrochloric_acid_eq_frac * hcl_hhso4 +                                      &
+                      ammonium_sulphate_eq_frac * nh42so4_hhso4 +                                  &
+                      ammonium_nitrate_eq_frac  * nh4no3_hhso4 +                                   &
+                      ammonium_chloride_eq_frac * nh4cl_hhso4 +                                    &
+                      sodium_sulphate_eq_frac   * na2so4_hhso4 +                                   &
+                      sodium_nitrate_eq_frac * nano3_hhso4 + sodium_chloride_eq_frac   * nacl_hhso4
+
+       gamma_hhso4 = EXP( ln_hhso4_act )   ! molal activity coefficient of HHSO4
 
 !--    H2SO4 (sulphuric acid):
-       IF ( RH >= 0.1_wp  .AND.  RH < 0.9_wp )  THEN
-          binary_h2so4 = 2.4493_wp * ( RH**2 ) - 6.2326_wp * RH + 2.1763_wp
-       ELSEIF ( RH >= 0.9_wp  .AND.  RH < 0.98 )  THEN
-          binary_h2so4 = 914.68_wp * ( RH**3 ) - 2502.3_wp * ( RH**2 ) +       &
-                         2281.9_wp * RH - 695.11_wp
-       ELSEIF ( RH >= 0.98  .AND.  RH < 0.9999 )  THEN
-          binary_h2so4 = 3E-8_wp * ( RH**4 ) - 5E-6_wp * ( RH**3 ) +           &
-                       0.0003_wp * ( RH**2 ) - 0.0022_wp * RH - 1.1305_wp
-       ENDIF
-       
+       IF ( rh >= 0.1_wp  .AND.  rh < 0.9_wp )  THEN
+          binary_h2so4 = 2.4493_wp * rh**2 - 6.2326_wp * rh + 2.1763_wp
+       ELSEIF ( rh >= 0.9_wp  .AND.  rh < 0.98 )  THEN
+          binary_h2so4 = 914.68_wp * rh**3 - 2502.3_wp * rh**2 + 2281.9_wp * rh - 695.11_wp
+       ELSEIF ( rh >= 0.98  .AND.  rh < 0.9999 )  THEN
+          binary_h2so4 = 3.0E-8_wp * rh**4 - 5E-6_wp * rh**3 + 0.0003_wp * rh**2 - 0.0022_wp *     &
+                         rh - 1.1305_wp
+       ENDIF
+
        IF ( nitric_acid > 0.0_wp )  THEN
-          HNO3_h2so4 = - 16.382_wp * ( RH**5 ) + 46.677_wp * ( RH**4 ) -       &
-                         54.149_wp * ( RH**3 ) + 34.36_wp * ( RH**2 ) -        &
-                         12.54_wp * RH + 2.1368_wp
-       ENDIF
-       
+          hno3_h2so4 = - 16.382_wp * rh**5 + 46.677_wp * rh**4 - 54.149_wp * rh**3 + 34.36_wp *    &
+                         rh**2 - 12.54_wp * rh + 2.1368_wp
+       ENDIF
+
        IF ( hydrochloric_acid > 0.0_wp )  THEN
-          HCL_h2so4 = - 14.409_wp * ( RH**5 ) + 42.804_wp * ( RH**4 ) -        &
-                         47.24_wp * ( RH**3 ) + 24.668_wp * ( RH**2 ) -        &
-                        5.8015_wp * RH + 0.084627_wp
-       ENDIF
-       
+          hcl_h2so4 = - 14.409_wp * rh**5 + 42.804_wp * rh**4 - 47.24_wp * rh**3 + 24.668_wp *     &
+                        rh**2 - 5.8015_wp * rh + 0.084627_wp
+       ENDIF
+
        IF ( ammonium_sulphate > 0.0_wp )  THEN
-          NH42SO4_h2so4 = 66.71_wp * ( RH**5 ) - 187.5_wp * ( RH**4 ) +        &
-                         210.57_wp * ( RH**3 ) - 121.04_wp * ( RH**2 ) +       &
-                         39.182_wp * RH - 8.0606_wp
-       ENDIF
-       
+          nh42so4_h2so4 = 66.71_wp * rh**5 - 187.5_wp * rh**4 + 210.57_wp * rh**3 - 121.04_wp *    &
+                          rh**2 + 39.182_wp * rh - 8.0606_wp
+       ENDIF
+
        IF ( ammonium_nitrate > 0.0_wp )  THEN
-          NH4NO3_h2so4 = - 22.532_wp * ( RH**4 ) + 66.615_wp * ( RH**3 ) -     &
-                           74.647_wp * ( RH**2 ) + 37.638_wp * RH - 6.9711_wp 
-       ENDIF
-       
+          nh4no3_h2so4 = - 22.532_wp * rh**4 + 66.615_wp * rh**3 - 74.647_wp * rh**2 + 37.638_wp * &
+                         rh - 6.9711_wp
+       ENDIF
+
        IF ( ammonium_chloride > 0.0_wp )  THEN
-          IF ( RH >= 0.1_wp  .AND.  RH < 0.2_wp )  THEN
-             NH4Cl_h2so4 = - 0.32089_wp * RH + 0.57738_wp
-          ELSEIF ( RH >= 0.2_wp  .AND.  RH < 0.9_wp )  THEN
-             NH4Cl_h2so4 = 18.089_wp * ( RH**5 ) - 51.083_wp * ( RH**4 ) +     &
-                            50.32_wp * ( RH**3 ) - 17.012_wp * ( RH**2 ) -     &
-                          0.93435_wp * RH + 1.0548_wp
-          ELSEIF ( RH >= 0.9_wp  .AND.  RH < 0.99_wp )  THEN
-             NH4Cl_h2so4 = - 1.5749_wp * RH + 1.7002_wp
+          IF ( rh >= 0.1_wp  .AND.  rh < 0.2_wp )  THEN
+             nh4cl_h2so4 = - 0.32089_wp * rh + 0.57738_wp
+          ELSEIF ( rh >= 0.2_wp  .AND.  rh < 0.9_wp )  THEN
+             nh4cl_h2so4 = 18.089_wp * rh**5 - 51.083_wp * rh**4 + 50.32_wp * rh**3 - 17.012_wp *  &
+                           rh**2 - 0.93435_wp * rh + 1.0548_wp
+          ELSEIF ( rh >= 0.9_wp  .AND.  rh < 0.99_wp )  THEN
+             nh4cl_h2so4 = - 1.5749_wp * rh + 1.7002_wp
           ENDIF
        ENDIF
-       
+
        IF ( sodium_sulphate > 0.0_wp )  THEN
-          Na2SO4_h2so4 = 29.843_wp * ( RH**4 ) - 69.417_wp * ( RH**3 ) +       &
-                         61.507_wp * ( RH**2 ) - 29.874_wp * RH + 7.7556_wp
-       ENDIF
-       
+          na2so4_h2so4 = 29.843_wp * rh**4 - 69.417_wp * rh**3 + 61.507_wp * rh**2 - 29.874_wp *   &
+                         rh + 7.7556_wp
+       ENDIF
+
        IF ( sodium_nitrate > 0.0_wp )  THEN
-          NaNO3_h2so4 = - 122.37_wp * ( RH**6 ) + 427.43_wp * ( RH**5 ) -      &
-                          604.68_wp * ( RH**4 ) + 443.08_wp * ( RH**3 ) -      &
-                          178.61_wp * ( RH**2 ) + 37.242_wp * RH - 1.9564_wp
-       ENDIF
-       
+          nano3_h2so4 = - 122.37_wp * rh**6 + 427.43_wp * rh**5 - 604.68_wp * rh**4 + 443.08_wp *  &
+                        rh**3 - 178.61_wp * rh**2 + 37.242_wp * rh - 1.9564_wp
+       ENDIF
+
        IF ( sodium_chloride > 0.0_wp )  THEN
-          NaCl_h2so4 = - 40.288_wp * ( RH**5 ) + 115.61_wp * ( RH**4 ) -       &
-                         129.99_wp * ( RH**3 ) + 72.652_wp * ( RH**2 ) -       &
-                         22.124_wp * RH + 4.2676_wp
-       ENDIF
-       
-       Ln_h2so4_act = binary_h2so4 +                                           &
-                      nitric_acid_eq_frac       * HNO3_h2so4 +                 &
-                      hydrochloric_acid_eq_frac * HCL_h2so4 +                  &
-                      ammonium_sulphate_eq_frac * NH42SO4_h2so4 +              &
-                      ammonium_nitrate_eq_frac  * NH4NO3_h2so4 +               &
-                      ammonium_chloride_eq_frac * NH4Cl_h2so4 +                &
-                      sodium_sulphate_eq_frac   * Na2SO4_h2so4 +               &
-                      sodium_nitrate_eq_frac    * NaNO3_h2so4 +                &
-                      sodium_chloride_eq_frac   * NaCl_h2so4                     
-
-       gamma_h2so4 = EXP( Ln_h2so4_act )    ! molal activity coefficient 
-!          
+          nacl_h2so4 = - 40.288_wp * rh**5 + 115.61_wp * rh**4 - 129.99_wp * rh**3 + 72.652_wp *   &
+                       rh**2 - 22.124_wp * rh + 4.2676_wp
+       ENDIF
+
+       ln_h2so4_act = binary_h2so4 + nitric_acid_eq_frac * hno3_h2so4 +                            &
+                      hydrochloric_acid_eq_frac * hcl_h2so4 +                                      &
+                      ammonium_sulphate_eq_frac * nh42so4_h2so4 +                                  &
+                      ammonium_nitrate_eq_frac  * nh4no3_h2so4 +                                   &
+                      ammonium_chloride_eq_frac * nh4cl_h2so4 +                                    &
+                      sodium_sulphate_eq_frac * na2so4_h2so4 +                                     &
+                      sodium_nitrate_eq_frac * nano3_h2so4 + sodium_chloride_eq_frac * nacl_h2so4
+
+       gamma_h2so4 = EXP( ln_h2so4_act )    ! molal activity coefficient 
+!
 !--    Export activity coefficients
        IF ( gamma_h2so4 > 1.0E-10_wp )  THEN
-          gamma_out(4) = ( gamma_hhso4**2.0_wp ) / gamma_h2so4
+          gamma_out(4) = gamma_hhso4**2 / gamma_h2so4
        ENDIF
        IF ( gamma_hhso4 > 1.0E-10_wp )  THEN
-          gamma_out(5) = ( gamma_h2so4**3.0_wp ) / ( gamma_hhso4**2.0_wp )
+          gamma_out(5) = gamma_h2so4**3 / gamma_hhso4**2
        ENDIF
 !
 !--    Ionic activity coefficient product
-       act_product = ( gamma_h2so4**3.0_wp ) / ( gamma_hhso4**2.0_wp )
+       act_product = gamma_h2so4**3 / gamma_hhso4**2
 !
 !--    Solve the quadratic equation (i.e. x in ax**2 + bx + c = 0)
        a = 1.0_wp
-       b = - 1.0_wp * ( ions(4) + ions(1) + ( ( water_total * 18.0E-3_wp ) /   &
-          ( 99.0_wp * act_product ) ) )
+       b = -1.0_wp * ( ions(4) + ions(1) + ( ( water_total * 18.0E-3_wp ) /                        &
+           ( 99.0_wp * act_product ) ) )
        c = ions(4) * ions(1)
-       root1 = ( ( -1.0_wp * b ) + ( ( ( b**2 ) - 4.0_wp * a * c )**0.5_wp     &
-               ) ) / ( 2 * a )
-       root2 = ( ( -1.0_wp * b ) - ( ( ( b**2 ) - 4.0_wp * a * c) **0.5_wp     &
-               ) ) / ( 2 * a )
+       root1 = ( ( -1.0_wp * b ) + ( ( ( b**2 ) - 4.0_wp * a * c )**0.5_wp ) ) / ( 2.0_wp * a )
+       root2 = ( ( -1.0_wp * b ) - ( ( ( b**2 ) - 4.0_wp * a * c) **0.5_wp ) ) / ( 2.0_wp * a )
 
        IF ( root1 > ions(1)  .OR.  root1 < 0.0_wp )  THEN
@@ -6485,15 +6459,10 @@
           root2 = 0.0_wp
        ENDIF
-!          
+!
 !--    Calculate the new hydrogen ion, bisulphate ion and sulphate ion 
 !--    concentration
-       hso4_real = 0.0_wp
        h_real    = ions(1)
        so4_real  = ions(4)
-       IF ( root1 == 0.0_wp )  THEN
-          hso4_real = root2
-       ELSEIF ( root2 == 0.0_wp )  THEN
-          hso4_real = root1
-       ENDIF
+       hso4_real = MAX( root1, root2 )
        h_real   = ions(1) - hso4_real
        so4_real = ions(4) - hso4_real
@@ -6507,6 +6476,6 @@
        hso4_out = hso4_real
        so4_out  = so4_real
-       
-    ELSEIF ( ions(1) == 0.0_wp  .OR.  ions(4) == 0.0_wp )  THEN
+
+    ELSE
        h_out    = ions(1)
        hso4_out = 0.0_wp
